diff -Ncr linux-2.4.22-ashuariadevel.backup/include/linux/fs.h linux-2.4.22-ashuariadevel/include/linux/fs.h
*** linux-2.4.22-ashuariadevel.backup/include/linux/fs.h	2004-01-19 17:47:35.000000000 +0900
--- linux-2.4.22-ashuariadevel/include/linux/fs.h	2004-02-02 15:20:57.000000000 +0900
***************
*** 249,255 ****
  struct buffer_head {
  	/* First cache line: */
  	struct buffer_head *b_next;	/* Hash queue list */
! 	unsigned long b_blocknr;	/* block number */
  	unsigned short b_size;		/* block size */
  	unsigned short b_list;		/* List that this buffer appears */
  	kdev_t b_dev;			/* device (B_FREE = free) */
--- 249,255 ----
  struct buffer_head {
  	/* First cache line: */
  	struct buffer_head *b_next;	/* Hash queue list */
! 	sector_t b_blocknr;		/* block number */
  	unsigned short b_size;		/* block size */
  	unsigned short b_list;		/* List that this buffer appears */
  	kdev_t b_dev;			/* device (B_FREE = free) */
***************
*** 398,410 ****
  	int (*prepare_write)(struct file *, struct page *, unsigned, unsigned);
  	int (*commit_write)(struct file *, struct page *, unsigned, unsigned);
  	/* Unfortunately this kludge is needed for FIBMAP. Don't use it */
! 	int (*bmap)(struct address_space *, long);
  	int (*flushpage) (struct page *, unsigned long);
  	int (*releasepage) (struct page *, int);
  #define KERNEL_HAS_O_DIRECT /* this is for modules out of the kernel */
! 	int (*direct_IO)(int, struct inode *, struct kiobuf *, unsigned long, int);
  #define KERNEL_HAS_DIRECT_FILEIO /* Unfortunate kludge due to lack of foresight */
! 	int (*direct_fileIO)(int, struct file *, struct kiobuf *, unsigned long, int);
  	void (*removepage)(struct page *); /* called when page gets removed from the inode */
  };
  
--- 398,410 ----
  	int (*prepare_write)(struct file *, struct page *, unsigned, unsigned);
  	int (*commit_write)(struct file *, struct page *, unsigned, unsigned);
  	/* Unfortunately this kludge is needed for FIBMAP. Don't use it */
! 	sector_t (*bmap)(struct address_space *, sector_t);
  	int (*flushpage) (struct page *, unsigned long);
  	int (*releasepage) (struct page *, int);
  #define KERNEL_HAS_O_DIRECT /* this is for modules out of the kernel */
! 	int (*direct_IO)(int, struct inode *, struct kiobuf *, sector_t, int);
  #define KERNEL_HAS_DIRECT_FILEIO /* Unfortunate kludge due to lack of foresight */
! 	int (*direct_fileIO)(int, struct file *, struct kiobuf *, sector_t, int);
  	void (*removepage)(struct page *); /* called when page gets removed from the inode */
  };
  
***************
*** 462,468 ****
  	time_t			i_ctime;
  	unsigned int		i_blkbits;
  	unsigned long		i_blksize;
! 	unsigned long		i_blocks;
  	unsigned long		i_version;
  	unsigned short          i_bytes;
  	struct semaphore	i_sem;
--- 462,468 ----
  	time_t			i_ctime;
  	unsigned int		i_blkbits;
  	unsigned long		i_blksize;
! 	sector_t		i_blocks;
  	unsigned long		i_version;
  	unsigned short          i_bytes;
  	struct semaphore	i_sem;
***************
*** 1298,1304 ****
  extern void sync_supers(kdev_t dev, int wait);
  extern void sync_supers_lockfs(kdev_t);
  extern void unlockfs(kdev_t);
! extern int bmap(struct inode *, int);
  extern int notify_change(struct dentry *, struct iattr *);
  extern int permission(struct inode *, int);
  extern int vfs_permission(struct inode *, int);
--- 1298,1304 ----
  extern void sync_supers(kdev_t dev, int wait);
  extern void sync_supers_lockfs(kdev_t);
  extern void unlockfs(kdev_t);
! extern sector_t bmap(struct inode *, sector_t);
  extern int notify_change(struct dentry *, struct iattr *);
  extern int permission(struct inode *, int);
  extern int vfs_permission(struct inode *, int);
***************
*** 1455,1462 ****
  extern void remove_inode_hash(struct inode *);
  extern struct file * get_empty_filp(void);
  extern void file_move(struct file *f, struct list_head *list);
! extern struct buffer_head * get_hash_table(kdev_t, int, int);
! extern struct buffer_head * getblk(kdev_t, int, int);
  extern void ll_rw_block(int, int, struct buffer_head * bh[]);
  extern void submit_bh(int, struct buffer_head *);
  extern int is_read_only(kdev_t);
--- 1455,1462 ----
  extern void remove_inode_hash(struct inode *);
  extern struct file * get_empty_filp(void);
  extern void file_move(struct file *f, struct list_head *list);
! extern struct buffer_head * get_hash_table(kdev_t, sector_t, int);
! extern struct buffer_head * getblk(kdev_t, sector_t, int);
  extern void ll_rw_block(int, int, struct buffer_head * bh[]);
  extern void submit_bh(int, struct buffer_head *);
  extern int is_read_only(kdev_t);
***************
*** 1475,1490 ****
  extern int set_blocksize(kdev_t, int);
  extern int sb_set_blocksize(struct super_block *, int);
  extern int sb_min_blocksize(struct super_block *, int);
! extern struct buffer_head * bread(kdev_t, int, int);
! static inline struct buffer_head * sb_bread(struct super_block *sb, int block)
  {
  	return bread(sb->s_dev, block, sb->s_blocksize);
  }
! static inline struct buffer_head * sb_getblk(struct super_block *sb, int block)
  {
  	return getblk(sb->s_dev, block, sb->s_blocksize);
  }
! static inline struct buffer_head * sb_get_hash_table(struct super_block *sb, int block)
  {
  	return get_hash_table(sb->s_dev, block, sb->s_blocksize);
  }
--- 1475,1490 ----
  extern int set_blocksize(kdev_t, int);
  extern int sb_set_blocksize(struct super_block *, int);
  extern int sb_min_blocksize(struct super_block *, int);
! extern struct buffer_head * bread(kdev_t, sector_t, int);
! static inline struct buffer_head * sb_bread(struct super_block *sb, sector_t block)
  {
  	return bread(sb->s_dev, block, sb->s_blocksize);
  }
! static inline struct buffer_head * sb_getblk(struct super_block *sb, sector_t block)
  {
  	return getblk(sb->s_dev, block, sb->s_blocksize);
  }
! static inline struct buffer_head * sb_get_hash_table(struct super_block *sb, sector_t block)
  {
  	return get_hash_table(sb->s_dev, block, sb->s_blocksize);
  }
***************
*** 1493,1501 ****
  extern void put_unused_buffer_head(struct buffer_head * bh);
  extern struct buffer_head * get_unused_buffer_head(int async);
  
! extern int brw_page(int, struct page *, kdev_t, int [], int);
  
! typedef int (get_block_t)(struct inode*,long,struct buffer_head*,int);
  
  /* Generic buffer handling for block filesystems.. */
  extern int try_to_release_page(struct page * page, int gfp_mask);
--- 1493,1501 ----
  extern void put_unused_buffer_head(struct buffer_head * bh);
  extern struct buffer_head * get_unused_buffer_head(int async);
  
! extern int brw_page(int, struct page *, kdev_t, sector_t [], int);
  
! typedef int (get_block_t)(struct inode*,sector_t,struct buffer_head*,int);
  
  /* Generic buffer handling for block filesystems.. */
  extern int try_to_release_page(struct page * page, int gfp_mask);
***************
*** 1512,1521 ****
  extern int block_commit_write(struct page *page, unsigned from, unsigned to);
  extern int block_sync_page(struct page *);
  
! int generic_block_bmap(struct address_space *, long, get_block_t *);
  int generic_commit_write(struct file *, struct page *, unsigned, unsigned);
  int block_truncate_page(struct address_space *, loff_t, get_block_t *);
! extern int generic_direct_IO(int, struct inode *, struct kiobuf *, unsigned long, int, get_block_t *);
  extern int waitfor_one_page(struct page *);
  extern int writeout_one_page(struct page *);
  
--- 1512,1521 ----
  extern int block_commit_write(struct page *page, unsigned from, unsigned to);
  extern int block_sync_page(struct page *);
  
! sector_t generic_block_bmap(struct address_space *, sector_t, get_block_t *);
  int generic_commit_write(struct file *, struct page *, unsigned, unsigned);
  int block_truncate_page(struct address_space *, loff_t, get_block_t *);
! extern int generic_direct_IO(int, struct inode *, struct kiobuf *, sector_t, int, get_block_t *);
  extern int waitfor_one_page(struct page *);
  extern int writeout_one_page(struct page *);
  
diff -Ncr linux-2.4.22-ashuariadevel.backup/include/linux/genhd.h linux-2.4.22-ashuariadevel/include/linux/genhd.h
*** linux-2.4.22-ashuariadevel.backup/include/linux/genhd.h	2004-01-19 17:47:35.000000000 +0900
--- linux-2.4.22-ashuariadevel/include/linux/genhd.h	2004-02-02 15:20:57.000000000 +0900
***************
*** 59,66 ****
  #  include <linux/devfs_fs_kernel.h>
  
  struct hd_struct {
! 	unsigned long start_sect;
! 	unsigned long nr_sects;
  	devfs_handle_t de;              /* primary (master) devfs entry  */
  #ifdef CONFIG_DEVFS_FS
  	int number;
--- 59,66 ----
  #  include <linux/devfs_fs_kernel.h>
  
  struct hd_struct {
! 	sector_t start_sect;
! 	sector_t nr_sects;
  	devfs_handle_t de;              /* primary (master) devfs entry  */
  #ifdef CONFIG_DEVFS_FS
  	int number;
***************
*** 94,100 ****
  	int max_p;			/* maximum partitions per device */
  
  	struct hd_struct *part;		/* [indexed by minor] */
! 	int *sizes;			/* [idem], device size in blocks */
  	int nr_real;			/* number of real devices */
  
  	void *real_devices;		/* internal use */
--- 94,100 ----
  	int max_p;			/* maximum partitions per device */
  
  	struct hd_struct *part;		/* [indexed by minor] */
! 	sector_t *sizes;		/* [idem], device size in blocks */
  	int nr_real;			/* number of real devices */
  
  	void *real_devices;		/* internal use */
diff -Ncr linux-2.4.22-ashuariadevel.backup/include/linux/ide.h linux-2.4.22-ashuariadevel/include/linux/ide.h
*** linux-2.4.22-ashuariadevel.backup/include/linux/ide.h	2004-01-19 17:47:35.000000000 +0900
--- linux-2.4.22-ashuariadevel/include/linux/ide.h	2004-02-02 15:20:57.000000000 +0900
***************
*** 1148,1154 ****
  	int		(*suspend)(ide_drive_t *);
  	int		(*resume)(ide_drive_t *);
  	int		(*flushcache)(ide_drive_t *);
! 	ide_startstop_t	(*do_request)(ide_drive_t *, struct request *, unsigned long);
  	int		(*end_request)(ide_drive_t *, int);
  	u8		(*sense)(ide_drive_t *, const char *, u8);
  	ide_startstop_t	(*error)(ide_drive_t *, const char *, u8);
--- 1148,1154 ----
  	int		(*suspend)(ide_drive_t *);
  	int		(*resume)(ide_drive_t *);
  	int		(*flushcache)(ide_drive_t *);
! 	ide_startstop_t	(*do_request)(ide_drive_t *, struct request *, sector_t);
  	int		(*end_request)(ide_drive_t *, int);
  	u8		(*sense)(ide_drive_t *, const char *, u8);
  	ide_startstop_t	(*error)(ide_drive_t *, const char *, u8);
***************
*** 1159,1165 ****
  	int		(*media_change)(ide_drive_t *);
  	void		(*revalidate)(ide_drive_t *);
  	void		(*pre_reset)(ide_drive_t *);
! 	unsigned long	(*capacity)(ide_drive_t *);
  	ide_startstop_t	(*special)(ide_drive_t *);
  	ide_proc_entry_t	*proc;
  	int		(*init)(void);
--- 1159,1165 ----
  	int		(*media_change)(ide_drive_t *);
  	void		(*revalidate)(ide_drive_t *);
  	void		(*pre_reset)(ide_drive_t *);
! 	sector_t	(*capacity)(ide_drive_t *);
  	ide_startstop_t	(*special)(ide_drive_t *);
  	ide_proc_entry_t	*proc;
  	int		(*init)(void);
***************
*** 1570,1576 ****
  extern int set_transfer(ide_drive_t *, ide_task_t *);
  extern int taskfile_lib_get_identify(ide_drive_t *drive, u8 *);
  
! extern ide_startstop_t __ide_do_rw_disk(ide_drive_t *, struct request *, unsigned long);
  /*
   * ide_system_bus_speed() returns what we think is the system VESA/PCI
   * bus speed (in MHz).  This is used for calculating interface PIO timings.
--- 1570,1576 ----
  extern int set_transfer(ide_drive_t *, ide_task_t *);
  extern int taskfile_lib_get_identify(ide_drive_t *drive, u8 *);
  
! extern ide_startstop_t __ide_do_rw_disk(ide_drive_t *, struct request *, sector_t);
  /*
   * ide_system_bus_speed() returns what we think is the system VESA/PCI
   * bus speed (in MHz).  This is used for calculating interface PIO timings.
diff -Ncr linux-2.4.22-ashuariadevel.backup/include/linux/iobuf.h linux-2.4.22-ashuariadevel/include/linux/iobuf.h
*** linux-2.4.22-ashuariadevel.backup/include/linux/iobuf.h	2004-01-19 17:47:35.000000000 +0900
--- linux-2.4.22-ashuariadevel/include/linux/iobuf.h	2004-02-02 15:20:57.000000000 +0900
***************
*** 42,48 ****
  
  	struct page **  maplist;
  	struct buffer_head ** bh;
! 	unsigned long * blocks;
  
  	/* Dynamic state for IO completion: */
  	atomic_t	io_count;	/* IOs still in progress */
--- 42,48 ----
  
  	struct page **  maplist;
  	struct buffer_head ** bh;
! 	sector_t * blocks;
  
  	/* Dynamic state for IO completion: */
  	atomic_t	io_count;	/* IOs still in progress */
***************
*** 74,79 ****
  /* fs/buffer.c */
  
  int	brw_kiovec(int rw, int nr, struct kiobuf *iovec[], 
! 		   kdev_t dev, unsigned long b[], int size);
  
  #endif /* __LINUX_IOBUF_H */
--- 74,79 ----
  /* fs/buffer.c */
  
  int	brw_kiovec(int rw, int nr, struct kiobuf *iovec[], 
! 		   kdev_t dev, sector_t b[], int size);
  
  #endif /* __LINUX_IOBUF_H */
diff -Ncr linux-2.4.22-ashuariadevel.backup/include/linux/iso_fs.h linux-2.4.22-ashuariadevel/include/linux/iso_fs.h
*** linux-2.4.22-ashuariadevel.backup/include/linux/iso_fs.h	2004-01-19 17:47:35.000000000 +0900
--- linux-2.4.22-ashuariadevel/include/linux/iso_fs.h	2004-02-02 15:20:57.000000000 +0900
***************
*** 219,225 ****
  int get_acorn_filename(struct iso_directory_record *, char *, struct inode *);
  
  extern struct dentry *isofs_lookup(struct inode *, struct dentry *);
! extern struct buffer_head *isofs_bread(struct inode *inode, unsigned int block);
  extern int isofs_get_blocks(struct inode *, long, struct buffer_head **, unsigned long);
  
  extern struct inode_operations isofs_dir_inode_operations;
--- 219,225 ----
  int get_acorn_filename(struct iso_directory_record *, char *, struct inode *);
  
  extern struct dentry *isofs_lookup(struct inode *, struct dentry *);
! extern struct buffer_head *isofs_bread(struct inode *inode, sector_t block);
  extern int isofs_get_blocks(struct inode *, long, struct buffer_head **, unsigned long);
  
  extern struct inode_operations isofs_dir_inode_operations;
***************
*** 234,240 ****
  #define brelse leak_check_brelse
  extern void * leak_check_malloc(unsigned int size);
  extern void leak_check_free_s(void * obj, int size);
! extern struct buffer_head * leak_check_bread(struct super_block *sb, int block);
  extern void leak_check_brelse(struct buffer_head * bh);
  #endif /* LEAK_CHECK */
  
--- 234,240 ----
  #define brelse leak_check_brelse
  extern void * leak_check_malloc(unsigned int size);
  extern void leak_check_free_s(void * obj, int size);
! extern struct buffer_head * leak_check_bread(struct super_block *sb, sector_t block);
  extern void leak_check_brelse(struct buffer_head * bh);
  #endif /* LEAK_CHECK */
  
diff -Ncr linux-2.4.22-ashuariadevel.backup/include/linux/loop.h linux-2.4.22-ashuariadevel/include/linux/loop.h
*** linux-2.4.22-ashuariadevel.backup/include/linux/loop.h	2003-12-09 11:52:14.000000000 +0900
--- linux-2.4.22-ashuariadevel/include/linux/loop.h	2004-02-02 14:35:10.000000000 +0900
***************
*** 34,40 ****
  	int		lo_flags;
  	int		(*transfer)(struct loop_device *, int cmd,
  				    char *raw_buf, char *loop_buf, int size,
! 				    int real_block);
  	char		lo_name[LO_NAME_SIZE];
  	char		lo_encrypt_key[LO_KEY_SIZE];
  	__u32           lo_init[2];
--- 34,40 ----
  	int		lo_flags;
  	int		(*transfer)(struct loop_device *, int cmd,
  				    char *raw_buf, char *loop_buf, int size,
! 				    sector_t real_block);
  	char		lo_name[LO_NAME_SIZE];
  	char		lo_encrypt_key[LO_KEY_SIZE];
  	__u32           lo_init[2];
***************
*** 133,139 ****
  struct loop_func_table {
  	int number; 	/* filter type */ 
  	int (*transfer)(struct loop_device *lo, int cmd, char *raw_buf,
! 			char *loop_buf, int size, int real_block);
  	int (*init)(struct loop_device *, struct loop_info *); 
  	/* release is called from loop_unregister_transfer or clr_fd */
  	int (*release)(struct loop_device *); 
--- 133,139 ----
  struct loop_func_table {
  	int number; 	/* filter type */ 
  	int (*transfer)(struct loop_device *lo, int cmd, char *raw_buf,
! 			char *loop_buf, int size, sector_t real_block);
  	int (*init)(struct loop_device *, struct loop_info *); 
  	/* release is called from loop_unregister_transfer or clr_fd */
  	int (*release)(struct loop_device *); 
diff -Ncr linux-2.4.22-ashuariadevel.backup/include/linux/msdos_fs.h linux-2.4.22-ashuariadevel/include/linux/msdos_fs.h
*** linux-2.4.22-ashuariadevel.backup/include/linux/msdos_fs.h	2004-01-19 17:47:35.000000000 +0900
--- linux-2.4.22-ashuariadevel/include/linux/msdos_fs.h	2004-02-02 15:20:57.000000000 +0900
***************
*** 272,278 ****
  extern struct inode_operations fat_file_inode_operations;
  extern ssize_t fat_file_read(struct file *filp, char *buf, size_t count,
  			     loff_t *ppos);
! extern int fat_get_block(struct inode *inode, long iblock,
  			 struct buffer_head *bh_result, int create);
  extern ssize_t fat_file_write(struct file *filp, const char *buf, size_t count,
  			      loff_t *ppos);
--- 272,278 ----
  extern struct inode_operations fat_file_inode_operations;
  extern ssize_t fat_file_read(struct file *filp, char *buf, size_t count,
  			     loff_t *ppos);
! extern int fat_get_block(struct inode *inode, sector_t iblock,
  			 struct buffer_head *bh_result, int create);
  extern ssize_t fat_file_write(struct file *filp, const char *buf, size_t count,
  			      loff_t *ppos);
diff -Ncr linux-2.4.22-ashuariadevel.backup/include/linux/nfs_fs.h linux-2.4.22-ashuariadevel/include/linux/nfs_fs.h
*** linux-2.4.22-ashuariadevel.backup/include/linux/nfs_fs.h	2004-01-19 17:47:35.000000000 +0900
--- linux-2.4.22-ashuariadevel/include/linux/nfs_fs.h	2004-02-02 15:20:57.000000000 +0900
***************
*** 284,290 ****
  /*
   * linux/fs/nfs/direct.c
   */
! extern int  nfs_direct_IO(int, struct file *, struct kiobuf *, unsigned long, int);
  
  /*
   * linux/fs/mount_clnt.c
--- 284,290 ----
  /*
   * linux/fs/nfs/direct.c
   */
! extern int  nfs_direct_IO(int, struct file *, struct kiobuf *, sector_t, int);
  
  /*
   * linux/fs/mount_clnt.c
diff -Ncr linux-2.4.22-ashuariadevel.backup/include/linux/qnx4_fs.h linux-2.4.22-ashuariadevel/include/linux/qnx4_fs.h
*** linux-2.4.22-ashuariadevel.backup/include/linux/qnx4_fs.h	2000-06-30 07:53:42.000000000 +0900
--- linux-2.4.22-ashuariadevel/include/linux/qnx4_fs.h	2004-02-02 14:35:10.000000000 +0900
***************
*** 118,124 ****
  extern int qnx4_rmdir(struct inode *dir, struct dentry *dentry);
  extern int qnx4_sync_file(struct file *file, struct dentry *dentry, int);
  extern int qnx4_sync_inode(struct inode *inode);
! extern int qnx4_get_block(struct inode *inode, long iblock, struct buffer_head *bh, int create);
  
  #endif				/* __KERNEL__ */
  
--- 118,124 ----
  extern int qnx4_rmdir(struct inode *dir, struct dentry *dentry);
  extern int qnx4_sync_file(struct file *file, struct dentry *dentry, int);
  extern int qnx4_sync_inode(struct inode *inode);
! extern int qnx4_get_block(struct inode *inode, sector_t iblock, struct buffer_head *bh, int create);
  
  #endif				/* __KERNEL__ */
  
diff -Ncr linux-2.4.22-ashuariadevel.backup/include/linux/raid/linear.h linux-2.4.22-ashuariadevel/include/linux/raid/linear.h
*** linux-2.4.22-ashuariadevel.backup/include/linux/raid/linear.h	2004-01-19 17:47:35.000000000 +0900
--- linux-2.4.22-ashuariadevel/include/linux/raid/linear.h	2004-02-02 15:20:57.000000000 +0900
***************
*** 5,12 ****
  
  struct dev_info {
  	kdev_t		dev;
! 	unsigned long	size;
! 	unsigned long	offset;
  };
  
  typedef struct dev_info dev_info_t;
--- 5,12 ----
  
  struct dev_info {
  	kdev_t		dev;
! 	sector_t	size;
! 	sector_t	offset;
  };
  
  typedef struct dev_info dev_info_t;
diff -Ncr linux-2.4.22-ashuariadevel.backup/include/linux/raid/md.h linux-2.4.22-ashuariadevel/include/linux/raid/md.h
*** linux-2.4.22-ashuariadevel.backup/include/linux/raid/md.h	2004-01-19 17:47:35.000000000 +0900
--- linux-2.4.22-ashuariadevel/include/linux/raid/md.h	2004-02-02 15:20:57.000000000 +0900
***************
*** 60,66 ****
  #define MD_MINOR_VERSION                90
  #define MD_PATCHLEVEL_VERSION           0
  
! extern int md_size[MAX_MD_DEVS];
  extern struct hd_struct md_hd_struct[MAX_MD_DEVS];
  
  extern void add_mddev_mapping (mddev_t *mddev, kdev_t dev, void *data);
--- 60,66 ----
  #define MD_MINOR_VERSION                90
  #define MD_PATCHLEVEL_VERSION           0
  
! extern sector_t md_size[MAX_MD_DEVS];
  extern struct hd_struct md_hd_struct[MAX_MD_DEVS];
  
  extern void add_mddev_mapping (mddev_t *mddev, kdev_t dev, void *data);
diff -Ncr linux-2.4.22-ashuariadevel.backup/include/linux/raid/md_k.h linux-2.4.22-ashuariadevel/include/linux/raid/md_k.h
*** linux-2.4.22-ashuariadevel.backup/include/linux/raid/md_k.h	2003-06-13 23:51:39.000000000 +0900
--- linux-2.4.22-ashuariadevel/include/linux/raid/md_k.h	2004-02-02 14:35:10.000000000 +0900
***************
*** 164,170 ****
  
  	kdev_t dev;			/* Device number */
  	kdev_t old_dev;			/*  "" when it was last imported */
! 	unsigned long size;		/* Device size (in blocks) */
  	mddev_t *mddev;			/* RAID array if running */
  	unsigned long last_events;	/* IO event timestamp */
  
--- 164,170 ----
  
  	kdev_t dev;			/* Device number */
  	kdev_t old_dev;			/*  "" when it was last imported */
! 	sector_t size;		/* Device size (in blocks) */
  	mddev_t *mddev;			/* RAID array if running */
  	unsigned long last_events;	/* IO event timestamp */
  
***************
*** 172,178 ****
  
  	mdp_super_t *sb;
  	struct page *sb_page;
! 	unsigned long sb_offset;
  
  	int alias_device;		/* device alias to the same disk */
  	int faulty;			/* if faulty do not issue IO requests */
--- 172,178 ----
  
  	mdp_super_t *sb;
  	struct page *sb_page;
! 	sector_t sb_offset;
  
  	int alias_device;		/* device alias to the same disk */
  	int faulty;			/* if faulty do not issue IO requests */
diff -Ncr linux-2.4.22-ashuariadevel.backup/include/linux/types.h linux-2.4.22-ashuariadevel/include/linux/types.h
*** linux-2.4.22-ashuariadevel.backup/include/linux/types.h	2004-01-19 17:47:35.000000000 +0900
--- linux-2.4.22-ashuariadevel/include/linux/types.h	2004-02-02 15:20:57.000000000 +0900
***************
*** 134,137 ****
--- 134,142 ----
  	char			f_fpack[6];
  };
  
+ #ifndef HAVE_ARCH_SECTOR_T
+ typedef unsigned long sector_t;
+ #endif
+ #define HAVE_SECTOR_T 1
+ 
  #endif /* _LINUX_TYPES_H */
diff -Ncr linux-2.4.22-ashuariadevel.backup/mm/page_io.c linux-2.4.22-ashuariadevel/mm/page_io.c
*** linux-2.4.22-ashuariadevel.backup/mm/page_io.c	2002-11-29 08:53:15.000000000 +0900
--- linux-2.4.22-ashuariadevel/mm/page_io.c	2004-02-02 14:35:10.000000000 +0900
***************
*** 36,42 ****
  static int rw_swap_page_base(int rw, swp_entry_t entry, struct page *page)
  {
  	unsigned long offset;
! 	int zones[PAGE_SIZE/512];
  	int zones_used;
  	kdev_t dev = 0;
  	int block_size;
--- 36,42 ----
  static int rw_swap_page_base(int rw, swp_entry_t entry, struct page *page)
  {
  	unsigned long offset;
! 	sector_t zones[PAGE_SIZE/512];
  	int zones_used;
  	kdev_t dev = 0;
  	int block_size;
***************
*** 55,61 ****
  		block_size = PAGE_SIZE;
  	} else if (swapf) {
  		int i, j;
! 		unsigned int block = offset
  			<< (PAGE_SHIFT - swapf->i_sb->s_blocksize_bits);
  
  		block_size = swapf->i_sb->s_blocksize;
--- 55,61 ----
  		block_size = PAGE_SIZE;
  	} else if (swapf) {
  		int i, j;
! 		sector_t block = offset
  			<< (PAGE_SHIFT - swapf->i_sb->s_blocksize_bits);
  
  		block_size = swapf->i_sb->s_blocksize;
